## EDU.oswego.cs.dl.util.concurrent
Class Latch

    java.lang.Object
      EDU.oswego.cs.dl.util.concurrent.Latch

All Implemented Interfaces:
  Sync

    public class Latch

extends java.lang.Object
implements Sync

A latch is a boolean condition that is set at most once, ever. Once a single release is issued, all acquires will pass.

Sample usage. Here are a set of classes that use a latch as a start signal for a group of worker threads that are created and started beforehand, and then later enabled.

     class Worker implements Runnable {
       private final Latch startSignal;
       Worker(Latch l) { startSignal = l; }
        public void run() {
          startSignal.acquire();
          doWork();
       }
       void doWork() { ... }
     }

     class Driver { // ...
       void main() {
         Latch go = new Latch();
         for (int i = 0; i < N; ++i) // make threads
           new Thread(new Worker(go)).start();
         doSomethingElse();         // don't let run yet
         go.release();              // let all threads proceed
       }
     }

[ Introduction to this package. ]

Field Summary
`protected boolean` `latched_`

Fields inherited from interface EDU.oswego.cs.dl.util.concurrent.Sync
`ONE_CENTURY, ONE_DAY, ONE_HOUR, ONE_MINUTE, ONE_SECOND, ONE_WEEK, ONE_YEAR`

Constructor Summary
`Latch()`

Method Summary
`void` `acquire()` Wait (possibly forever) until successful passage.
`boolean` `attempt(long msecs)` Wait at most msecs to pass; report whether passed.
`void` `release()` Enable all current and future acquires to pass

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### latched_

    protected boolean latched_

Constructor Detail

### Latch

    public Latch()

Method Detail

### acquire

    public void acquire()
                 throws java.lang.InterruptedException

  Description copied from interface: `Sync`
  Wait (possibly forever) until successful passage. Fail only upon interuption. Interruptions always result in `clean' failures. On failure, you can be sure that it has not been acquired, and that no corresponding release should be performed. Conversely, a normal return guarantees that the acquire was successful.

  Specified by:
    `acquire` in interface `Sync`
  Throws:
    `java.lang.InterruptedException`

### attempt

    public boolean attempt(long msecs)
                    throws java.lang.InterruptedException

  Description copied from interface: `Sync`
  Wait at most msecs to pass; report whether passed.

  The method has best-effort semantics: The msecs bound cannot be guaranteed to be a precise upper bound on wait time in Java. Implementations generally can only attempt to return as soon as possible after the specified bound. Also, timers in Java do not stop during garbage collection, so timeouts can occur just because a GC intervened. So, msecs arguments should be used in a coarse-grained manner. Further, implementations cannot always guarantee that this method will return at all without blocking indefinitely when used in unintended ways. For example, deadlocks may be encountered when called in an unintended context.

  Specified by:
    `attempt` in interface `Sync`
  Parameters:
    `msecs` - the number of milleseconds to wait. An argument less than or equal to zero means not to wait at all. However, this may still require access to a synchronization lock, which can impose unbounded delay if there is a lot of contention among threads.
  Returns:
    true if acquired
  Throws:
    `java.lang.InterruptedException`

### release

    public void release()

  Enable all current and future acquires to pass

  Specified by:
    `release` in interface `Sync`